use clap::Parser;
use std::time::Duration;

/// Victim client
#[derive(Parser, Debug)]
#[command(version, about, long_about = None)]
struct Args {
    /// Target server address
    #[arg(short, long, default_value = "http://localhost:8000")]
    target_server: String,

    /// Interval of time between two request, in seconds
    #[arg(short, long, default_value_t = 3)]
    pause_between_requests: usize,
}

#[tokio::main]
async fn main() -> Result<(), Box<dyn std::error::Error>> {
    env_logger::init_from_env(env_logger::Env::new().default_filter_or("info"));

    let args = Args::parse();

    let url = format!("{}/confid_req", args.target_server);

    loop {
        log::info!("Sending a new request to {url}");
        let client = reqwest::Client::new();
        let res = client
            .post(&url)
            .body("Top secret body with confidential information")
            .send()
            .await;

        match res {
            Err(e) => log::error!("Failed to perform request: {e}"),
            Ok(res) => {
                log::info!("Response status: {}", res.status());
            }
        }

        std::thread::sleep(Duration::from_secs(args.pause_between_requests as u64));
    }
}

#[cfg(test)]
mod test {
    use crate::Args;
    #[test]
    fn verify_cli() {
        use clap::CommandFactory;
        Args::command().debug_assert()
    }
}
